#include <stdlib.h>
#include <stdio.h>
#include <conio.h>
#include <dos.h>
#include <io.h>

//#pragma inline
volatile unsigned long counter;
static void interrupt (far *oldtimer)(...);   /* BIOS timer handler */
static char fname [13] = "SCREEN_A.SCR";
void deinit_timer (void);

static void interrupt new_timer (...) {
   asm cli
   counter++;
   if (counter < 300) {
     oldtimer();
   } else {
     asm { mov al, 0x20; out 0x20, al; sti }
     setvect (8, oldtimer);
     counter = 0;

  char c = 0;
  int x1 = 0, y1 = 0, x2 = 319, y2 = 199, i, j;
  unsigned char far* screen =
    (unsigned char far*) ((void _seg*)(0xA000) + (void near*)(0));

  int file = _creat (fname, 0);
  if (file == -1) printf ("%s",strerror(errno));
  i = x2-x1; _write (file, &i, 2);
  i = y2-y1; _write (file, &i, 2);
  for (i=0; i<256; i++) {
    outp(0x3c7,i);
    for (j=0; j<3; j++) {
      c = inp(0x3c9);
      _write (file, &c, 1);
    }
  }
  for (i=x1; i<=x2; i++)
    for (j=y1; j<=y2; j++)
      _write (file, (void*) &screen[i+(320*j)], 1);
  _close (file);
  fname[7]++;
  setvect (8, new_timer);
  }
  pquit:
   asm sti
}


/* see that 1st line of inline asm?
   to set whatever clock speed you want load
   bx with 1193180/x where x is the clock speed you want in Hz. */
void init_timer (void) {
//   slow_tick = fast_tick=0l;
   oldtimer = getvect(8); // save old timer
   asm cli
   // speed up clock
   asm {
     mov bx, 19886     //  set the clock speed to 60Hz (1193180/60)
     mov al, 00110110b
     out 0x43, al
     mov al,  bl
     out 0x40, al
     mov al, bh
     out 0x40, al
   }
   setvect(8, new_timer);
   asm sti
}


void deinit_timer (void) {
   asm cli
   // slow down clock   1193180 / 65536 = 18.2, but we use zero
   asm {
      xor bx, bx          // min rate 18.2 Hz when set to zero
      mov al, 00110110b
      out 0x43, al
      mov al, bl
      out 0x40, al
      mov al, bh
      out 0x40, al
   }
   setvect(8, oldtimer);  // restore oldtimer
   asm sti
}


void main () {
  char cmd[80], tmp;
  int pos = 0;

  printf ("Command> ");

  while (pos != -1) {
    tmp = getche ();
    if (tmp == 13) {
      cmd[pos] = 0; pos = -1;
    } else {
      cmd[pos] = tmp; pos++;
    }
  }

  init_timer ();
  system (cmd);
  deinit_timer ();
}
